\documentclass[a4paper]{article}

\usepackage{graphicx} % Required for inserting images
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{amsmath}
\usepackage{amsthm}
\usepackage{amssymb}
\usepackage[numbers]{natbib}
\usepackage{pgfplots}
\usepackage[version=4]{mhchem}
\pgfplotsset{width=7.5cm,compat=1.9}
\usepackage{subfigure}
\usepackage{geometry}
\usepackage[hidelinks]{hyperref}
\usepackage[makeroom]{cancel}
\usepackage{pdflscape}
\usepackage{makecell}
\usepackage{tikz}
\usepackage{upgreek}
\usepackage{lineno}
\usepackage{xr}


\hypersetup{
    colorlinks=true,
    linkcolor=blue,
    filecolor=magenta,
    citecolor=blue,
    urlcolor=blue,
    pdftitle={Analytic solutions},
}
\geometry{top=2cm,bottom=2cm,left=1.75cm,right=1.75cm}

\setlength{\parindent}     {0cm}
\setlength{\parskip}       {0.3cm}

\newtheorem{theorem}{Theorem}[section]
\newtheorem{lemma}[theorem]{Lemma}

\include{math}

% ------------------------------------------------------

\usetikzlibrary{shapes.geometric, arrows}

\tikzstyle{process} = [rectangle, rounded corners,
minimum width=5.4cm,
minimum height=2.5cm,
text centered,
text width=4cm,
draw=black,
fill=orange!30]

\tikzstyle{arrow} = [thick,->,>=stealth]

\externaldocument[]{main}

\renewcommand{\thefigure}  {S\arabic{figure}}
\renewcommand{\thetable}   {S\arabic{table}}
\renewcommand{\theequation}{S\arabic{equation}}

% ------------------------------------------------------

\begin{document}

    \title{Optimal enzyme profiles in unbranched metabolic pathways -- Supplementary Text}
    \author{Elad Noor$^{1*}$ and Wolfram Liebermeister$^{2*}$}
    \date{}

\maketitle

$^1$ Department of Plant and Environmental Sciences, Weizmann Institute of Science, 76100 Rehovot, Israel\\
$^2$ Universit\'e Paris-Saclay, INRAE, MaIAGE, 78350 Jouy-en-Josas, France\\
$*$ Corresponding authors, equal contributions

\section{Code availability}

All the data, scripts, and resulting plots used in this work are freely available at \url{https://gitlab.com/elad.noor/optimal_enzyme_investment} under an MIT open-source license.

\section{Symbols}

Mathematical symbols are listed in Table \ref{tab:symbols}.

\begin{table}[h!]
\centering
    \begin{tabular}{l|c}
        Parameter name & symbol \\
        \hline
        Turnover constant & $\kcat$ \\
        Turnover constant (forward) & $\kcatplus$ \\
        Turnover constant (backward) & $\kcatminus$ \\
        Thermodynamic equilibrium constant & $\Keq$ \\
        Michaelis-Menten constant & $\km$ \\
        Michaelis-Menten constant (substrate) & $\kmx{S}$ \\
        Michaelis-Menten constant (product) & $\kmx{P}$ \\
        Thermodynamic driving force & $\theta$ \\
        Reaction rate & $\flux$ \\
        Pathway flux & $\fluxJ$ \\
        Enzyme concentration/demand & $\enzyme$
    \end{tabular}
    \caption{The names of the variables and constants used in this work, along with their mathematical symbol.}
    \label{tab:symbols}
\end{table}


\section{Revisiting the enzyme-control rule}

\subsection{Why the enzyme-control rule fails with Michaelis-Menten kinetics}
\label{sec:WhyEnzymeControlRuleFails}

The enzyme-control rule fails in a very simple case, the unbranched metabolic pathway with Michaelis-Menten rate laws. We can easily see this. Since the rate law is irreversible, the rate in each reaction depends only on the substrate and enzyme level (and not on anything that happens downstream). In steady state, all reaction rates are given by the stationary flux. Taken together, this means that the flux depends only on the initial pathway substrate and the level of the first enzyme, so this enzyme has full flux control and all other enzymes have zero control. However, according to the enzyme-control rule, this would mean that the first enzyme is the only enzyme that should be expressed. This is obviously wrong: without the other enzymes, no steady flux would be possible. So how can this be?

In fact, optimal steady states in models  with irreversible rate laws have some pathological properties. To maximize enzyme efficiency, all metabolite levels must go to infinity, so the enzymes are completely saturated and the metabolite elasticities are all zero. As a result, the flux in every reaction is given by $\fluxi = \enzymei ~ \kcati$, so the stationary flux completely determines all enzyme levels. If an enzyme level deviates from its prescribed value, its reaction rate  will no longer match the other rates and the steady state breaks down\footnote{In fact, there are a number of similar arguments why the  enzyme-control rules fails in this case. First, the  state with infinite concentrations does not exist mathematically, so formally we cannot even refer to it as a metabolic state; second, even if this state existed, all elasticities would vanish, and the Jacobian matrix would not be invertible, so the control coefficient would not be defined; third, even if we could argue that, logically, the first enzyme must have full flux control, the same argument would also apply to all other enzymes: each of the enzymes would have full flux control, thus violating the summation theorem.}. Now we can see what went wrong: in the optimal state, any small change of an enzyme level will break the steady state; this means that the control coefficients are not even defined, and the enzyme-control rule cannot apply. All this does not only occur with the Michaelis-Menten rate law, but with any  irreversible, saturable rate law.

In the case of the Michaelis-Mention rate law, the practical solution to this problem is simple. Since the optimal state requires infinite metabolite concentrations, and since this is not a realistic assumption, we need to change our model. We may either consider slightly reversible rate laws (which would penalize high product concentrations) or introduce an extra density constraint that penalizes high metabolite levels.

\subsection{An enzyme-control rule for models with general density constraints}
\label{sec:enzymeControlRuleWithMetabolites}

One way to obtain meaningful optimal states, even with Michaelis-Menten kinetics, is to constrain the metabolite concentrations. The new optimality problem leads to different solutions and to a different enzyme-control rule.

Aside from high enzyme levels, also high metabolite concentrations may put a burden on cells, and considering this burden leads to different solutions for enzyme levels. Setting up optimality problems with such a constraint raises a couple of questions: should we use separate constraints on enzyme levels and on metabolite concentrations, or just one  density constraint on their sum? How should the different compounds be weighted? In fact, the resulting optimality problems are not very different, and we demonstrate here one specific approach: we describe all compounds (enzymes and metabolites) by their concentrations and consider a bound on their weighted sum (where weights may have different meanings, for example molecular masses if the aim is to restrict the total mass density in the cell).

We thus consider the optimality problem
\begin{align}
\label{eq:OptProblemWithDensityConstraint}
\mbox{Maximize}\; \zweightv \cdot \vv \quad \mbox{s.t.}
\quad \aweightv \cdot \enzymev + \bweightv \cdot \vsmet \le \rho
\end{align}
where $\vv$, $\vsmet$, and $\enzymev$ denote vectors of reaction fluxes, metabolite concentrations, and enzyme levels, and where stationarity (of $\vv$) and rate laws (between $\vv$, $\vsmet$, and $\enzymev$) must be  satisfied as constraints. The maximization objective is a linear  benefit function $\zweightv \cdot \vv$ scoring the fluxes with linear weights $z_i$, while the constrained density is linear in all the concentrations, with linear weights\footnote{Instead of a linear flux objective, a nonlinear function $z(\vec{v})$ could be used. In this case, the rule (\ref{eq:EnzymeControlRuleMetaboliteConstraint1}) would have the same form, but with the gradient $\nabla_v z(\vv)$ replacing the weight vector $\vec{z}$. Likewise, in a model with separate density constraints $\aweightv \cdot \enzymev \le \rho_\enzyme$ and $\bweightv \cdot \vsmet \le \rho_c$, we obtain a similar formula, but with separate Lagrange multipliers for the two constraints.

}
$a_l$ (for enzymes) and  $b_i$ (for metabolites), e.g.~representing effective molecule sizes\footnote{For a simple constraint on the total mass, the weights are simply molecular weights, for example as a proxy for excluded volume (which would still ignore, for example, hydration shells). However, a "density constraint" need not represent space demands; it may also be used to describe osmotic effects or opportunity costs (e.g.~energy demand for production of compounds in growing cells). Therefore the meaning of the weights in the density constraint may differ from model to model.}.

To derive the enzyme-control rule, we now reformulate the optimality problem with enzyme levels as the only free variables and steady-state fluxes and concentrations depending on them (satisfying stationarity and the rate laws). We obtain the optimality problem
\begin{align}
\mbox{Maximize}\; \zweightv \cdot \vv^{\rm st}(\enzymev) \quad \mbox{s.t.}
\quad \aweightv \cdot \enzymev + \bweightv \cdot \vsmet^{\rm st}(\enzymev) \le \rho,
\end{align}
which leads to a new enzyme-control rule (proof in section \ref{sec:EnzymeControlRuleMetaboliteConstraintProof})
\begin{align}
\label{eq:EnzymeControlRuleMetaboliteConstraint1}
{\opt{\enzymev}}\trans ~\diag(\vec{a})~\diag(\vv)\inv  &=  \left[\frac{1}{\lambda} ~\vec{z}\trans \mathbf{C}^{\vec{v}*}  -  \vec{b}\trans {\Ccmat}^*\right].
\end{align}
Here $\mathbf{C}^{\vec{v}*}$ and ${\Ccmat}^*$ denote the unscaled control matrices for the fluxes and for the concentrations in the optimal state. In the general case (i.e., a network with different fluxes in different reactions) we obtain a more complicated flux benefit function with derivatives $\frac{\partial z}{\partial v_i}$, and individual weights $a_l$ and $b_i$ for all enzymes and metabolites. All these vectors would enter the formula as weights.

In a simple linear pathway, our rule can be simplified. We assume the same steady-state flux $\fluxJ$ in all the reactions, a benefit function given by $\fluxJ$ itself, and a density constraint with equal weights $a$ for all enzymes and equal weights $b$ for all the metabolites. In this case, Eq.~(\ref{eq:EnzymeControlRuleMetaboliteConstraint1}) simplifies to
\begin{align}
\label{eq:EnzymeControlRuleMetaboliteConstraint2}
\opt{\enzyme}_l  \propto C^{\fluxJ*}_l  - \lambda~ b ~ \sum_i C^{s_i*}_l
\end{align}
which replaces the enzyme control rule (\ref{eq:EnzymeControlRule}).
Given the sum of enyzme levels in the optimal state, called $\etotPWopt$, we can also write this as (see \ref{sec:EnzymeControlRuleMetaboliteConstraintProof})
\begin{align}
    \opt{\enzyme}_l = \etotPWopt~ C^{\fluxJ*}_l  - \frac{b}{a} ~\opt{\fluxJ}~ \sum_i C^{\smet{i}*}_l.
\end{align}

Compared to the original enzyme-control rule (\ref{eq:EnzymeControlRule}), the right-hand side now contains a second term: it is given by the metabolite control coefficients, summed over all metabolites, and with a known prefactor. If the ratio of cost weights $b/a$ is small compared to the flux, this term can be neglected and we reobtain our original enzyme-control rule.

\subsection{A sufficient condition for stable states in unbranched pathways}
\label{sec:ConditionStableStates}

Another case in which control coefficients are undefined are unstable metabolic states. In an unstable state, small perturbations or chemical noise could drive the system far away from its original state. In MCA, we only consider stable states, because in unstable states control coefficients may not be defined. A metabolic state is asymptotically stable if the Jacobian $\Nmat~\Eunc$ in this state has only negative eigenvalues. But how can we know about this in practice?

In section \ref{Sec:Appendix:stability}, we derive a sufficient (but not necessary) condition for stable steady states in unbranched metabolic pathways, based on Gershgorin's theorem: A steady state in an unbranched metabolic pathway is stable if (but not only if) the first reaction 1 is not completely irreversible (i.e.~it has a non-zero product elasticity), the last reaction is not completely saturated (i.e.~it has a non-zero substrate elasticity), and in all reactions in between, the substrate elasticity  is larger than the  (absolute) product elasticity. This condition is not just a check for our models, but it also describes a potential way in which cells could achieve stability. For a reversible mass-action rate law, the latter condition is satisfied if $\Keqi > 1$,
and the first two conditions are generally satisfied.


% --------------------------------------------------------------------

\section{The enzyme-elasticity rule}
\label{sec:EnzymeElasticityRule}

The connectivity theorem for flux control coefficients,
\begin{equation}
    \forall i ~~ \sum_j \Cvj \cdot E_{j,i} = 0,
\end{equation}
relates the flux control coefficients $\Cvj$ (between enzyme $\enzyme_j$ and the pathway flux $\fluxJ$) to the unscaled elasticities $E_{j,i} = \frac{\partial \flux_j}{\partial \smet{i}}$ (between metabolite $\smet{i}$ and reaction rate $\flux_j$). In optimal state, the enzyme-control rule tells us that control coefficients and enzyme levels must be proportional. Therefore we can replace $\Cvj$ with $\enzyme_j$ in the  equation above. For each metabolite $i$, we obtain the enzyme-elasticity rule
\begin{equation}\label{eqn:connectivity_theorem_elasticities1}
    \sum_j \enzyme_j \cdot E_{j,i} = 0\,.
\end{equation}
What does this rule mean in practice? In a linear pathway, each metabolite has only one producing and one consuming reaction (with indices $i$ and $i+1$, and we obtain the equality
\begin{align}
\label{eqn:connectivity_theorem_elasticities2}
    \begin{split}
        \frac{\enzyme_{i+1}}{\enzyme_i} = - \frac{E^{v_{i}}_{\smet{i}}}{E^{v_{i+1}}_{\smet{i}}} = \frac{|E^{v_{i}}_{\smet{i}}|}{E^{v_{i+1}}_{\smet{i}}}.
    \end{split}
\end{align}
In the last step, we used the fact that the backward (product) elasticity $E^{v_{i}}_{\smet{i}}$ is negative and the forward (substrate) elasticity $E^{v_{i+1}}_{\smet{i}}$ is positive.

For didactical reasons, let us check this rule for models with mass-action rate laws. With the mass-action kinetic rate law in the form  $\flux_j = \enzyme_j \cdot (k_j \smet{j-1} - k_{-j} \smet{j})$ (see section \ref{Appendix:ana_ma_derivation}), Eq.~(\ref{eqn:summation_theorem_elasticities}) becomes:
\begin{align}\label{eqn:summation_theorem_elasticities}
    \begin{split}
        \forall i ~~~~ 0 &= \enzymei \cdot \frac{\partial \fluxi}{\partial \smet{i}} + \enzyme_{i-1} \cdot \frac{\partial \flux_{i-1}}{\partial \smet{i}}
        =
        \enzymei \cdot \left( -\enzymei k_{-i}\right) + \enzyme_{i+1} \cdot \left( \enzyme_{i+1} k_{i+1}\right)
    \end{split}
\end{align}
which by rearranging leads us to the relationship:
\begin{align}
    \forall i ~~~~ \frac{\enzyme_{i+1}}{\enzymei} &= \sqrt{\frac{k_{-i}}{k_{i+1}}}
    =
    \sqrt{\frac{\parma_{i+1}}{\parma_{i}}}
\end{align}
(where we remind ourselves of the definition $\parma_i \equiv k_{-i}^{-1} \prod_{j=1}^{i} k_{-j}/k_{j}$). Applying this equation recursively, we can see that $\enzymei/\enzyme_1 = \sqrt{\parma_{i} / \parma_1}$, which means that $\enzymei$ is proportional to $\sqrt{\parma_i}$. Since we know that the sum of all enzyme demands gives $\etotPW$, we can obtain  the explicit formula for $\enzymei$:
\begin{align}
    \enzyme_i
    &=
    \etotPW \frac{\sqrt{\parma_i}}{\sum_j \sqrt{\parma_j}}
    =
    \etotPW ~ \sqrt{ \frac{\parma_i}{\normhalf{\parma}} }\,.
\end{align}
This is the exact same result we got by directly optimizing the pathway flux (see Equation (\ref{Appendix:eqn:ana_ma_enzyme_solution})  in section \ref{Appendix:ana_ma_derivation}).

% --------------------------------------------------------------------

\section{Mathematical derivations and proofs}

The remaining sections contain many of the detailed mathematical proofs and derivations used in the article for metabolic steady-states, minimum enzyme demand or maximal flux, connectivity theorem, and enzyme control rules. The derivations are grouped by the corresponding rate law in the following order: (1) Michaelis-Menten; (2) Thermodynamic; (3) Reversible mass-action; (4) Haldane.
An overview of useful equations is given in Table \ref{tab:FormulaOverview1}.

\begin{table}[t]
\begin{center}
\scalebox{0.9}{
\begin{tabular}{l|llllll}
 & $\smet{i}^{\rm st}(\smet{0},\smet{n},\enzymev)$ & $\fluxJ(\smet{0},\smet{n},\enzymev)$ &
 $\smet{i}(\smet{0},\fluxJ,\enzymev)$ & Elasticities & $\Ccmat$ & $\Cvmat$ \\\hline
Michaelis-Menten & Eq.~(\ref{Appendix:eq:MMsteadyConcentrations1}) & $v_1(\smet{0})$
& Eq.~(\ref{Appendix:eq:MMsteadyConcentrations2}) &
Eq.~(\ref{eq:MMelasticities}) & & Eq.~(\ref{eq:MMfluxControl}) \\
Thermodynamic (const $\eta^{\rm kin}$) & Eq.~(\ref{eq:THsteadyConcentrations}) & & Eq.~(\ref{eq:THsteadyConcentrations}) & & Eq.~(\ref{eq:ConcentrationControlThermodynamic1})\\
Thermodynamic (substrate sat)  & & & & & & sec \ref{sec:FLuxControlThermoRateLaw}\\
Mass-action & Eq.~(\ref{eqn:ana_ma_flux_upper_bound}) & Eq.~(\ref{eq:MAsImplicit}) & & Eq.~(\ref{eq:MAelasticities}) & & sec \ref{sec:MAfluxControl}\\
Haldane & - & - & Eq.~(19) in \cite{HeinrichKlipp1996} & e.g.~\cite{LiebermeisterUhlendorf2010} & - & -\\
\end{tabular}
}
\end{center}
\caption{
Overview of formulae for steady-state variables and control coefficients. This table summarizes formulae for unbranched metabolic pathways with different rate laws (rows). The columns refer to steady-state concentrations and flux (as a function of enzyme levels and metabolite concentrations); steady-state concentrations as a function of enzyme levels, pathway substrate concentration, and steady-state flux (but not of the product concentration); reaction elasticities; and concentration and flux control coefficients.
}
\label{tab:FormulaOverview1}
\end{table}

\subsection{Michaelis-Menten kinetics}
\label{Appendix:mm_derivation}

The Michaelis-Menten rate law is an approximation of the Haldane rate law for irreversible reactions:
\begin{align}\label{Appendix:eq:MMRateLaw}
    \fluxi &= \enzymei ~ \kcati ~ \frac{\smet{i-1}}{\smet{i-1} + \kmi}
\end{align}
with reactant elasticities
\begin{eqnarray}
  \label{eq:MMelasticities}
   \frac{\partial \fluxi}{\partial \smet{j}} &= \delta_{j,i-1}~\enzymei ~ \kcati ~ \frac{\kmi}{(\smet{j} + \kmi)^{2}} \,.
\end{eqnarray}

\subsubsection{Steady-state concentrations}
\label{sec:MMsteadyStateConcentrations}

Computing the steady-state metabolite concentrations in a pathway with Michaelis-Menten kinetics is possible by inverting Eq.~(\ref{Appendix:eq:MMRateLaw}):
\begin{align}\label{Appendix:eq:MMsteadyConcentrations1}
    \begin{split}
    \smet{i-1} &= \frac{\fluxi}{\enzymei~\kcati}(\smet{i-1} + \kmi)
    \\
    \Rightarrow \smet{i-1}\left(1 - \frac{\fluxi}{\enzymei~\kcati}\right) &= \frac{\fluxi}{\enzymei~\kcati} \kmi
    \\
    \Rightarrow \smet{i-1} &= \frac{\fluxi \kmi}{\enzymei~\kcati (1 - \frac{\fluxi}{\enzymei~\kcati})} = \frac{\kmi}{\enzymei~\kcati/\fluxi - 1}\,.
    \end{split}
\end{align}
The steady-state concentrations as functions of the pathway flux can be found by replacing $\fluxi$ with $\fluxJ$ for all reactions. For any two reactions ($i$ and $j$), we can relate between their substrate levels by replacing $\fluxi$ in Eq.~(\ref{Appendix:eq:MMsteadyConcentrations1}) with $\fluxJ$ and using the rate law for $\fluxJ = \flux_j$ from Eq.~(\ref{Appendix:eq:MMRateLaw})
\begin{align}\label{Appendix:eq:MMsteadyConcentrations2}
    \begin{split}
    \smet{i-1} &=
    \frac{\kmi}{\enzymei~\kcati/\fluxJ - 1}
    =
    \frac{\kmi}{\enzymei~\kcati/\left(\enzyme_j ~ \kcatj ~ \frac{\smet{j-1}}{\smet{j-1} + K_{\mathrm{M},j}}\right) - 1}
    = \frac{\kmiplusone}{\frac{\enzymei \kcati}{\enzyme_j \kcatj} \left(1 + \frac{K_{\mathrm{M},j}}{\smet{j-1}}\right) - 1}.
    \end{split}
\end{align}

Applying this condition to all metabolites is a sufficient condition for having a steady-state. Specifically, if we start with a given concentration $\smet{0}$ and an enzyme abundance vector $\enzymev$, there is only one solution for the steady-state flux and for the metabolite levels ($\vsmet$) that support it.

\subsubsection{Flux control coefficients}

We can compute the flux control coefficients directly by taking derivatives: given that $\fluxJ=v_1$ and that $v_1$ depends only on the external substrate, described by a fixed parameter and therefore not dependent on the downstream $\enzyme_i$,  the
flux control coefficients read
\begin{align}
\label{eq:MMfluxControl}
    \Cvl= \frac{\partial \fluxJ}{\partial E_l} \cdot \frac{\enzyme_l}{\fluxJ} = \frac{\partial v_1}{\partial \enzyme_l} \frac{\enzyme_l}{v_1} = \delta_{l1}.
\end{align}
As expected, due to the irreversible rate law only the first enzyme can have control (except for the pathological case where metabolites concentrations become infinite and flux control is not defined).

\subsubsection{Minimum enzyme demand / maximal flux with a metabolite constraint}

At steady state (with flux $\fluxJ$),  Eq.~(\ref{Appendix:eq:MMRateLaw}) can also be used to express the enzyme demands:
\begin{align}
    \enzymei &= \frac{\fluxJ}{\kcati}\cdot \left(1 + \frac{\kmi}{\smet{i-1}}\right) =
    \fluxJ \left(\parthr_i + \frac{\parmm_i}{\smet{i-1}}\right)
\end{align}
where we defined $\parthr_i \equiv 1/\kcati$ and $\parmm_i \equiv \kmi/\kcati$ as before. Now we can equate the sum of all enzyme demands to $\etotPW$:
\begin{align}\label{Appendix:eqn:mm_etot_solution}
    \etotPW &= \fluxJ \left(\sum_{i=1}^n \parthr_i + \sum_{i=1}^n \frac{\parmm_i}{\smet{i-1}}\right)
    =
    \fluxJ \left(\normone{\parthr} + \sum_{i=1}^n \frac{\parmm_i}{\smet{i-1}}\right)
    \,.
\end{align}
This inverse relationship between $\etotPW$ and the metabolite concentrations means that in order to minimize $\etotPW$ for a given flux, all $\smet{i}$ should be as large as possible. Obviously, infinite concentrations are not feasible. To avoid such non-physical solutions, we can add a constraint on the total concentration of metabolites $\sum_{i=0}^{n-1} \smet{i} \leq \Stot$. Now, using Lagrange's method we define $\mathcal{L} = \fluxJ \left(\normone{\parthr} + \sum_i \parmm_i / \smet{i-1}\right) + \lambda \left(\sum_i \smet{i} - \Stot\right)$ and take the derivatives:
\begin{align}\label{Appendix:si_as_a_function_of_Sopt}
\begin{split}
    0
    =
    \frac{\partial \mathcal{L}}{\partial \smet{i-1}}
    &=
    -\frac{\parmm_i \opt{\fluxJ}}{{\smetopt{i-1}}^2} + \lambda
    \\
    \smetopt{i-1} &= \sqrt{\frac{\opt{\fluxJ}}{\lambda} } \sqrt{\parmm_i}.
\end{split}
\end{align}
To find $\lambda$, we can now use the constraint on the sum of all metabolites (assuming the upper bound is hit):
\begin{align}\label{Appendix:si_as_a_function_of_lambda}
\begin{split}
    \Stot &= \sum_{i=0}^{n-1} \smetopt{i}
    =
    \sqrt{\frac{\opt{\fluxJ}}{\lambda} }\left(\sum_{i=0}^{n-1} \sqrt{\parmm_i}\right)
    =
    \sqrt{\frac{\opt{\fluxJ}}{\lambda} } \sqrt{\normhalf{\parmm}}
\end{split}
\end{align}
where $\boldsymbol{\parmm}$ is the vector of all $\parmm_i$, and $\normhalf{\cdot}$ is the l$_{1/2}$ norm. Therefore, we can replace $\sqrt{\opt{\fluxJ} / \lambda}$ with $\Stot/\sqrt{\normhalf{\parmm}}$ in Eq.~(\ref{Appendix:si_as_a_function_of_Sopt}) and find an explicit expression for $\smetopt{i-1}$:
\begin{align}\label{Appendix:eqn:mm_optimal_s_i}
    \smetopt{i-1}
    &=
    \frac{\Stot}{\sqrt{\normhalf{\parmm} \cdot \parmm_i}}.
\end{align}
By combining the results from Eqs (\ref{Appendix:eqn:mm_etot_solution}) and (\ref{Appendix:eqn:mm_optimal_s_i}), we can see that:
\begin{align}\label{Appendix:eqn:mm_flux_solution}
\begin{split}
    \opt{\fluxJ}
    &=
    \frac{\etotPW}{\normone{\parthr} + \sum_i \parmm_i \big/ \smetopt{i-1} }
    =
    \frac{\etotPW}{\normone{\parthr} + \sum_i \sqrt{\parmm_i \cdot \normhalf{\parmm}} \big/ \Stot  }
    =
    \frac{\etotPW}{\normone{\parthr} + \normhalf{\parmm} \big/ \Stot}
\end{split}
\end{align}
and similarly we can find the optimal enzyme levels:
\begin{align}\label{Appendix:eqn:mm_flux_enzyme_solution}
    \opt{\enzymei} &= \opt{\fluxJ} \left(\parthr_i + \frac{\parmm_i}{\smetopt{i-1}}\right) = \etotPW ~ \frac{\parthr_i + \sqrt{\parmm_i ~\normhalf{\parmm}} \big/ \Stot}{\normone{\parthr} + \normhalf{\parmm} \big/ \Stot}.
 \end{align}

\subsubsection{Case where the first substrate has a fixed concentration} \label{Appendix:sec:mm_with_fixed_s0}

If our pathway model is used to describe a cell growing on an external substrate (S$_0$), then it would be unrealistic to assume that the concentration $\smet{0}$ is subject to optimization. Instead, we can assume it is fixed (e.g.~based on environmental conditions) and that the cell optimizes only the concentrations of enzymes and internal metabolites.

From Eq.~(\ref{Appendix:eqn:mm_flux_solution}) we can see that:
\begin{align}
    \fluxJ &= \frac{\etotPW}{\normone{\parthr} + \sum_i \parmm_i \big/ \smet{i-1}}
    =
    \frac{\etotPW}{\normone{\parthr} + \parmm_1/\smet{0} + \sum_{i=2}^n \parmm_i \big/ \smet{i-1}}
    \,.
\end{align}

Since $\smet{0}$ is fixed, we consider the term $\parmm_1/\smet{0}$ to be part of the constant part of the denominator (usually just $\sum_i 1/\kcati$). Furthermore, we can redefine $\normhalf{\parmm}$ to exclude the value for the first enzyme ($\parmm_1$) and impose the upper bound $\Stot$ only on the sum of internal metabolites. In this case, the solution we got in Eqs (\ref{Appendix:si_as_a_function_of_Sopt})-(\ref{Appendix:si_as_a_function_of_lambda}) will still be applicable, and therefore we can write:
\begin{align}
    \opt{\fluxJ}
    &=
    \frac{\etotPW}{\parmm_1/\smet{0} + \normone{\parthr} + \normhalf{\parmm} \big/ \Stot}
    =
    \mu^\mathrm{max} \cdot \frac{\smet{0}}{\smet{0} + K_\mathrm{Monod}}
\end{align}
where we defined
\begin{align}
    \begin{split}
        \mu^\mathrm{max} &\equiv \frac{\etotPW}{\normone{\parthr} + \normhalf{\parmm} \big/ \Stot}
        \\
        K_\mathrm{Monod} &\equiv \frac{\parmm_1}{\normone{\parthr} + \normhalf{\parmm} \big/ \Stot}
    \end{split}
\end{align}
As we can see, the solution provides a prediction for the Monod constant -- i.e., the concentration of substrate ($\smet{0}$) at which the growth rate reaches half of its maximum. If the transporter turnover constant ($k^\mathrm{cat}_1$) is indeed much slower than in all other enzymes, its control coefficient is 1 and we get $K_\mathrm{Monod} = K_{\mathrm{M,1}}$, which is often na\"{i}vely assumed. However, if the control is distributed along the pathway, the Monod constant can become significantly smaller than $K_{\mathrm{M,1}}$.

We also obtain expressions for the individual enzyme levels, using Eq.~(\ref{Appendix:eqn:mm_flux_enzyme_solution}). For the first enzyme, the substrate ($\smet{0}$) is fixed so the expression yields simply $\opt{\enzyme_1} = \opt{\fluxJ} \left(\parthr_1 + \parmm_1/\smet{0}\right)$, while for all other enzymes ($\forall i > 0$) we can use the solution for $\smetopt{i-1}$ from Eq.~(\ref{Appendix:eqn:mm_optimal_s_i}), i.e. $\opt{\enzymei} = \opt{\fluxJ} (\parthr_i +
\sqrt{\parmm_i ~\normhalf{\parmm}} / \Stot)$.

\subsubsection{Allocation of enyzmes in a cell model with Michaelis-Menten kinetics}

The cell model is described by three irreversible reactions:
\begin{equation}
    \mathrm{S}_{\rm sugar} \ce{<=>[\varepsilon_t]}
    \mathrm{S}_1           \ce{<=>[\varepsilon_m]}
    \mathrm{S}_2           \ce{<=>[\varepsilon_r]}
    \mathrm{S}_3
\end{equation}

The optimal achievable flux (or growth rate, denoted here as $\growth$) for a given total enzyme $\etotPW$ is given in Eqs (\ref{eq:CellMMfluxSolution1}-\ref{eq:CellMMfluxSolution2}). Figure \ref{Appendix:fig:cell_model_demands} shows the individual enzyme demands for the three steps, as a function of the external sugar concentration and $\growth$:
\begin{align}
    \begin{split}
        \opt{\enzyme}_{\rm t} &= \etotPW - \growth \cdot \left(1/\kcatx{\rm m} + 1/\kcatx{\rm r} + \left(\sqrt{K_\mathrm{M;m} / \kcatx{\rm m}} + \sqrt{K_\mathrm{M;r} / \kcatx{\rm r}}\right)^2 \Big/ \Stot \right)
        \\
        \opt{\enzyme}_{\rm m} &= \growth \cdot \left(1/\kcatx{\rm m} + \sqrt{K_\mathrm{M;m}/\kcatx{\rm m}} \left(\sqrt{K_\mathrm{M;m} / \kcatx{\rm m}} + \sqrt{K_\mathrm{M;r} / \kcatx{\rm r}}\right) \Big/ \Stot \right)
        \\
        \opt{\enzyme}_{\rm r} &= \growth \cdot \left(1/\kcatx{\rm r} + \sqrt{K_\mathrm{M;r}/\kcatx{\rm r}} \left(\sqrt{K_\mathrm{M;m} / \kcatx{\rm m}} + \sqrt{K_\mathrm{M;r} / \kcatx{\rm r}}\right) \Big/ \Stot \right)\,.
    \end{split}
\end{align}
Note that also $\opt{\enzyme}_{\rm m}$ and $\opt{\enzyme}_{\rm r}$ change with $s_{\rm sugar}$ even though it does not explicitly appear in the equations, because $\growth$ itself is a function of $s_{\rm sugar}$.

\begin{figure}[t]
    \centering
    \includegraphics[width=0.7\textwidth]{figure_S1.pdf}
    \caption{Enzyme demands in a simple cell model, depending on external sugar concentration. The abundances of the three enzyme sectors, when the allocation is optimal, as a function of the external sugar concentration ($s_{\rm sugar}$). The default parameters are $k^\mathrm{cat}_t = k^\mathrm{cat}_m = k^\mathrm{cat}_r = 1$, $K_\mathrm{M;t} = K_\mathrm{M;r} = 1$, $K_\mathrm{M;m} = 2$, $\Stot = 1$, and $\etotPW = 1$. In each panel only one of these parameters is changed.}
    \label{Appendix:fig:cell_model_demands}
\end{figure}


\subsection{Thermodynamic rate law with fixed kinetic efficiency}
\label{Appendix:thermo1_derivation}

The thermodynamic rate law with fixed kinetic efficiency reads:
\begin{equation}
    \fluxi = \enzymei~\kcati \left(1 - e^{-\theta_i}\right) = \enzymei~\kcati \left(1 - \frac{\smet{i}}{\smet{i-1}~\Keqi}\right)\,
\end{equation}
where the thermodynamic driving forces are given by $\theta_i \equiv \ln \left(\frac{\smet{i-1}\Keqi}{\smet{i}} \right)$.

\subsubsection{Steady-state concentrations}
Assuming a steady state (i.e.~all fluxes being equal to $\fluxJ$), we can find a simple recursion formula for the concentrations $\smet{i}$:
\begin{align}
    \smet{i} = \smet{i-1}~ \Keqi~ ( 1 - \fluxJ \cdot (\enzymei \kcati)^{-1} )\,.
\end{align}
By solving the recursion for $\smet{n}$ we get:
\begin{align}
\label{Appendix:eqn:THsteadyConcentrations}
    \smet{n} =
    \smet{n-1} ~\Keq_n~ ( 1 - \fluxJ \cdot (\enzyme_n~ k^\mathrm{cat}_n)^{-1} )
    = \ldots =
    \smet{0} \prod_{i=1}^n \Keqi ( 1 - \fluxJ \cdot (\enzymei~ \kcati)^{-1} )
    =
    \smet{0}~ \Keqtot \prod_{i=1}^n ( 1 - \fluxJ \cdot (\enzymei~ \kcati)^{-1} )\,,
\end{align}
where we used the fact that $\Keqtot = \prod_{i=1}^n \Keqi$.

The driving force of the entire pathway, which we denote by $\thetatot$, is the sum of all the individual driving forces:
\begin{align}\label{eqn:total_gibbs_energy_constraint}
\begin{split}
    \thetatot
    = \sum_{i=1}^n \theta_i
    = \sum_{i=1}^n \ln \left(\frac{\smet{i-1}~\Keqi}{\smet{i}} \right)
    = \ln\left( \prod_{i=1}^n \smet{i-1}/\smet{i} \right) + \ln{\left(\prod_{i=1}^n \Keqi\right)}
    = \ln{(\smet{0}/\smet{n})} + \ln{(\Keqtot)}\,.
\end{split}
\end{align}
Since $\thetatot$ depends only on $\Keqtot$, $\smet{0}$, and $\smet{n}$ -- all of which are constant -- it is a constant as well. Therefore, we can use this result to rewrite Eq.~(\ref{Appendix:eqn:THsteadyConcentrations}) as:
\begin{align}\label{Appendix:eqn:THsteadyConcentrations_log}
    \thetatot = - \sum_{i=1}^n \ln{( 1 - \fluxJ \cdot (\enzymei~ \kcati)^{-1} )}\,.
\end{align}

\subsubsection{Minimum enzyme demand / maximal flux}
\label{Appendix:thermo1_derivation_minimum_demand}

Directly solving the flux maximization problem using Eq.~(\ref{Appendix:eqn:THsteadyConcentrations_log}) would be difficult, because it cannot be solved analytically to find an expression for $\fluxJ$ as a function of enzyme levels. However, it is rather simple to do the opposite and express the enzyme levels as functions of $\fluxJ$ and the other parameters, sum them up, and compare to the total ($\etotPW$):
\begin{align} \label{eqn:flux_thermodynamic_bound}
    \begin{split}
        \enzymei &= \frac{\fluxJ}{\kcati \left(1 - e^{-\theta_i}\right)} = \fluxJ~ \frac{\parthr_i}{1 - e^{-\theta_i}}\\
        \frac{\etotPW}{\fluxJ} &\geq \frac{1}{\fluxJ} \sum_i \enzymei = \sum_i \parthr_i \left(1 - e^{-\theta_i}\right)^{-1}
    \end{split}
\end{align}
where again we define $\parthr_i \equiv 1/\kcati$.

Minimizing $\etotPW/\fluxJ$ is an optimization problem that can be solved directly using the $\smet{i}$ as variables, but it can be easier to solve if we consider the $\theta_i$ to be the independent variables instead. This variable switch is justified because there is a linear homomorphism between the two sets $\{\ln{\smet{i}}\}_{i=1}^{n-1}$ and $\{\theta_i\}_{i=1}^{n}$, given fixed $\smet{0}$ and $\smet{n}$ and under the constraint that $\sum{\theta_i} = \thetatot$.

Now, our aim is to find an optimal set of values for the driving forces, denoted $\opt{\theta_i}$, that sum up to $\thetatot$ and maximize $\fluxJ$ (similarly, $\opt{\fluxJ}$ and $\opt{\enzymei}$ would be the corresponding values of $\fluxJ$ and $\enzymei$ at the optimum).

\begin{lemma}\label{lemma:minimize_sum1}
The values of $x_i$ that minimize the function $\sum_i \parthr_i \left(1 - e^{-x_i}\right)^{-1}$ under the constraint $\sum_i x_i = x_{\rm tot}$, satisfy
\begin{align}
    x_i = 2~\mathrm{sinh}^{-1}\left( \sqrt{\Psi \parthr_i} \right)
\end{align}
for some $\Psi \in \mathbb{R}$.
\end{lemma}

\begin{proof}
Using Lagrange's method, we first define $\mathcal{L} = \sum_i \frac{\parthr_i}{1 - e^{-x_i}} + \lambda \left(\sum_i x_i - x_{\rm tot}\right)$
\begin{align}
    \begin{split}
    0 &= \frac{\partial  \mathcal{L}}{\partial x_i}
    =
    \frac{\parthr_i ~e^{-x_i}}{(1 - e^{-x_i})^2} + \lambda
    =
    \parthr_i \left(e^{x_i/2} - e^{-x_i/2}\right)^{-2} + \lambda
    \\
    \sqrt{-\frac{\parthr_i}{\lambda}} &= e^{x_i/2} - e^{-x_i/2} = 2~\mathrm{sinh}(x_i/2)
    \\
    x_i &= 2~\mathrm{sinh}^{-1}\left( \sqrt{\frac{\parthr_i}{-4\lambda}} \right)
    \end{split}
\end{align}
and if we define $\Psi = -\frac{1}{4\lambda}$, we can see that it proves the lemma.
\end{proof}

Using Lemma (\ref{lemma:minimize_sum1}), one can see that the optimal distribution of driving forces satisfies the following relationship, for some value of $\Psi$
\begin{align}
    \opt{\theta_i} = 2~\mathrm{sinh}^{-1}\left( \sqrt{\Psi \parthr_i} \right)
\end{align}
where the exact value of $\Psi$ can be determined by applying the constraint on the sum of $\theta_i$ from Eq.~(\ref{eqn:total_gibbs_energy_constraint}):
\begin{align} \label{eqn:total_gibbs_gamma}
    \begin{split}
    \ln \left(\frac{\smet{0}}{\smet{n}} \Keqtot\right) = \thetatot &= \sum_i \opt{\theta_i} = 2 \sum_i \mathrm{sinh}^{-1}\left( \sqrt{\Psi \parthr_i} \right)
    = 2 \sum_i \ln\left(\sqrt{\Psi \parthr_i} + \sqrt{1 + \Psi \parthr_i} \right)\,.
    \end{split}
\end{align}
Unfortunately, there is no analytical solution to this equation. Nevertheless, the function on the right-hand side is strictly monotonically increasing with $\Psi$ (in the entire range $\Psi \in \mathbb{R}$), so solving it numerically should be straightforward. Moreover, we can still express $\left(1 - e^{-\theta_i}\right)^{-1}$ as a function of $\Psi$:
\begin{align}
    \left(1 - e^{-\theta_i}\right)^{-1} = \left(1 - e^{-2 \cdot \mathrm{sinh}^{-1}( \sqrt{\Psi \parthr_i} )}\right)^{-1} = \frac{1}{2} + \frac{1}{2}\sqrt{1 + (\Psi \parthr_i)^{-1}} \,,
\end{align}
where we use the fact that $1-e^{-2\cdot\mathrm{sinh}^{-1}(x)} = 2/(1 + \sqrt{1 + x^{-2}})$. Therefore, the solutions for the maximal flux and individual enzyme allocations would be:
\begin{align}
    \begin{split}\label{Appendix:eqn:optEnzThermo}
        \opt{\fluxJ} &= \frac{\etotPW}{\sum_i \parthr_i \left(1 - e^{-\theta_i}\right)^{-1}} = \frac{2~\etotPW}{\sum_i \parthr_i \left(1+ \sqrt{1 + (\Psi\parthr_i)^{-1}} \right)}
        \\
        \opt{\enzymei}
        &=
        \opt{\fluxJ} \parthr_i~\frac{1}{2}  \left(1+\sqrt{1 + (\Psi \parthr_i)^{-1}} \right)
        \,.
    \end{split}
\end{align}

\subsubsection{Limit of small driving forces}
\label{Appendix:sec:close_to_equilibrium}

If we further assume that the total driving force $\thetatot$ is small (and therefore also each one of the reaction driving forces $\theta_i$ is even smaller), then we can write:
\begin{align}
    J \leq \etotPW \cdot \left( \sum_i \frac{1}{\kcati} \cdot \frac{1}{1 - e^{-\theta_i}} \right)^{-1} \approx \etotPW \cdot \left( \sum_i \frac{1}{\kcati~\theta_i} \right)^{-1}.
\end{align}

As we did before, the solution for $\opt{\fluxJ}$ can be found by minimizing $\etotPW/\fluxJ$ under the constraint $\sum_i \theta_i = \thetatot$, using the Lagrange method: $\mathcal{L} = \sum_i \frac{1}{\kcati~\theta_i} + \lambda (\sum_i\theta_i - \thetatot)$.
\begin{align}
    0
    &=
    \frac{\partial \mathcal{L}}{\partial \theta_i}
    =
    -\frac{1}{\kcati \cdot (\opt{\theta_i})^2} + \lambda
    \\
    \opt{\theta_i} &= \frac{1}{\sqrt{\lambda ~\kcati}}\,.
\end{align}
By applying the constraint $\thetatot = \sum_i \opt{\theta_i} = \lambda^{-1/2} \sum_i \sqrt{1/\kcati} \Rightarrow \sqrt{\lambda} = \thetatot^{-1} \cdot (\sum_i \sqrt{1/\kcati})$, we can write:
\begin{align}
\begin{split}
    \opt{\theta_i}
    &=
    \thetatot \frac{\sqrt{1/\kcati}}{\sum_i \sqrt{1/\kcati}}
    \\
    \opt{\fluxJ}
    &=
    \etotPW \cdot \left( \sum_i \frac{1}{\kcati~\opt{\theta_i}} \right)^{-1}
    =
    \frac{\thetatot ~ \etotPW}{\left(\sum_i \sqrt{1/\kcati}\right)^{2}}
    =
    \frac{\thetatot ~ \etotPW}{\normhalf{\parthr}}
\end{split}
\end{align}
and furthermore, we can see that:
\begin{equation}
    \opt{\enzymei}
    =
    \frac{\opt{\fluxJ}}{\kcati~\opt{\theta_i}}
    \propto
    \frac{1}{\kcati~\opt{\theta_i}}
    \propto
    \frac{1}{\kcati~\sqrt{1/\kcati}}
    =
    \sqrt{1/\kcati}
    =
    \sqrt{\parthr_i}\,.
\end{equation}

\subsection{Approximate analytical formula}
\label{sec:AppApproximateThermodynamic}

Based on the two limits for values of the total driving force ($\thetatot \rightarrow 0$ and $\thetatot \rightarrow \infty$), we can construct an approximation that converges with these limits for extreme values, following the template $a \cdot (1 - e^{-b~ \thetatot})$. The solutions for the two limits are:
\begin{align*}
    \lim_{\thetatot \rightarrow 0^+} \opt{\fluxJ} &= \frac{\thetatot ~ \etotPW}{\normhalf{\parthr}} \\
    \lim_{\thetatot \rightarrow \infty} \opt{\fluxJ} &= \frac{\etotPW}{\normone{\parthr}}\,.
\end{align*}
One can see that the approximate formula that has the same limits will be:
\begin{align}
    \begin{split}
    \label{Appendix:eqn:thermo_approximation}
    \opt{\fluxJ} &\approx \frac{\etotPW}{\normone{\parthr}} \left( 1 - \exp{
        \left(
        -\frac{\normone{\parthr}}{\normhalf{\parthr}} \thetatot \right)
    } \right)
    \\
    &=
    \frac{\etotPW}{\normone{\parthr}} \left( 1 - \exp{
        \left(
        \frac{\normone{\parthr}}{\normhalf{\parthr}} \ln\left(\frac{\smet{n}}{\smet{0} \Keqtot}\right) \right)
    } \right)
    \\
    &=
    \frac{\etotPW}{\normone{\parthr}}
    \left(
        1 - \left(\frac{\smet{n}}{\smet{0} \Keqtot}\right)^{\frac{\normone{\parthr}}{\normhalf{\parthr}}}
    \right)
    \end{split}
\end{align}

Figure \ref{Appendix:fig:thermo_solution_approximation1} illustrates how this approximation holds up against the precise solution (which is based on the closed-form formula, but requires inverting Eq.~(\ref{eqn:total_gibbs_gamma}) numerically to find $\Psi$). One can appreciate that the approximation is a very good one across all values of $\thetatot$ and for all choices of $\kcat$ values tested here. In Figure \ref{Appendix:fig:thermo_solution_approximation2}, we compare the approximation to solutions found numerically using convex optimization, i.e. directly optimizing $\fluxJ$ over the space of metabolite concentrations using a convex optimization solver (CVXPY \cite{diamond2016cvxpy, agrawal2018rewriting}).

\begin{figure}
    \centering
    \includegraphics[width=\textwidth]{figure_S2.pdf}
    \caption{Approximate formula for pathways with thermodynamic rate laws. Left panel: by re-scaling the x-axis by a factor of $||\alpha||_1/||\alpha||_{1/2}$ and transforming the y-axis using $y = -\ln{\left(1 - \opt{\fluxJ}/\etotPW \cdot \normone{\parthr} \right)}$, the precise solutions based on Eq.~(\ref{Appendix:eqn:optEnzThermo}) appear almost linear. Each curve represent a different set of $\kcat$ values and a varying number of enzymes in the pathway, between 1-4. The approximation based on Eq.~(\ref{Appendix:eqn:thermo_approximation}) is depicted by the dashed black line, which goes exactly along the diagonal for this set of axes. In the right panel, we plot the same precise solutions and approximations as in the left panel, but without transforming the axes.
    }
    \label{Appendix:fig:thermo_solution_approximation1}
\end{figure}

\begin{figure}
    \centering
    \includegraphics[width=0.6\textwidth]{figure_S3.pdf}
    \caption{Comparing the approximate solution for the thermodynamic rate law case to the numerical solution based on convex optimization. To arrive at the convex optimization solution (orange curve) we used CVXPY \cite{diamond2016cvxpy, agrawal2018rewriting}. The precise solution (based on the analytical formula from Eq.~(\ref{Appendix:eqn:optEnzThermo})) overlaps completely with the one using convex optimization and therefore is not shown. The dashed black line represent the approximate solution.
    In addition, we plot two other ``na\"ive'' approximations: a lower bound (pink dashed line) which represent the rate assuming that the driving force $\thetatot$ is uniformly distributed along the pathway -- i.e. for every reaction $\theta_i = \thetatot/n$ -- and an upper bound (violet dashed line) which represents a case where all the driving force is concentrated in one step, while all other steps have negligible cost.
    }
    \label{Appendix:fig:thermo_solution_approximation2}
\end{figure}

\subsubsection{Connectivity theorem}
\label{sec:TDrateLawConnectivityTheorem}

The unscaled metabolite elasticities for the thermodynamic rate law read
\begin{align}
E^{\flux_l}_{\smet{i}}\equiv \frac{\partial \flux_l}{\partial \smet{i}}
=
\frac{\partial}{\partial \smet{i}} \enzyme_l \kcatl \left(1-e^{-\theta_l(\vsmet)}\right)
=
\enzyme_l~\kcatl~e^{-\theta_l}~\frac{\partial \theta_l}{\partial \smet{i}}
=
\left(\enzyme_l~\kcatl - \fluxJ\right)\frac{\partial \theta_l}{\partial \smet{i}}.
\end{align}
In the last step we used the fact that $\enzyme_l~\kcatl~e^{-\theta_l} = \enzyme_l~\kcatl-\enzyme_l~\kcatl(1-e^{-\theta_l}) = \enzyme_l~\kcatl - \fluxJ$. With flux control coefficients proportional to $(\enzyme_l~\kcatl - \fluxJ)^{-1}$, we can now derive the connectivity theorem for each metabolite $\smet{i}$,
\begin{align}
\sum_l C^\fluxJ_l~E^{\fluxJ_l}_{\smet{i}} \propto \sum_l (\enzyme_l~\kcatl - \fluxJ)^{-1} (\enzyme_l~\kcatl - \fluxJ) ~\frac{\partial \theta_l}{\partial \smet{i}} = \sum_l \frac{\partial \theta_l}{\partial \smet{i}} = \sum_l \frac{n_{il}}{\smet{i}}=0.
\end{align}
Here we used $\theta_l=\theta_l^\circ + \sum_i n_{il} \ln \smet{i}$ with  derivative $\frac{\partial \theta_l}{\partial \smet{i}} = \frac{n_{il}}{\smet{i}}$ (in the second but last step), and the fact that our reactions are uni-molecular, with stoichiometric coefficients of $\pm$1 for substrate and products (in the last step).

\subsubsection{Flux control coefficients}
\label{sec:FLuxControlThermoRateLaw}

We start by turning Eq.~(\ref{Appendix:eqn:THsteadyConcentrations}) into an equality constraint:
\begin{equation}
    \label{eq:ThermoLawFLuxImplicit}
    \mathcal{Y} \equiv \prod_{i=1}^n \left(1 - \fluxJ (\enzymei~\kcati)^{-1} \right) - \frac{\smet{n}}{\smet{0}} \frac{1}{\Keqtot} = 0.
\end{equation}
This equation implicitly determines the flux $\fluxJ$ (given the enzyme levels $\enzyme_i$ and the external concentrations $\smet{0}$ and $\smet{n}$). Since $\fluxJ \le \enzyme_i~\kcati$, all product terms are positive and decreasing in $\fluxJ$, and so the entire product is a decreasing function of $\fluxJ$. Therefore, there can be only one solution with a positive flux. While Eq.~(\ref{eq:ThermoLawFLuxImplicit}) cannot be solved for $\fluxJ$ directly, it determines $\fluxJ$ implicitly and is sufficient for computing the flux response coefficients. For doing this we use the following lemma:

\begin{lemma}
\label{lemma:implicitDifferentiation} We consider two variables $x$ and $y$, constrained by an equality $f(x,y)=0$. We assume that for each given value of $x$, the constraint is satisfied by a single value of $y$, which we call $y=g(x)$. To compute the derivative $\partial g(x)/\partial x$ directly from $f(x,y)$ without an explicit expression for $g(x)$, we insert $g(x)$ and write the constraint as $h(x) = f(x,g(x))=0$. With the chain rule, we can write this as $0 =\frac{\partial h(x)}{\partial x} = \frac{\partial f(x,y)}{\partial x}|_{y=g(x)} + \frac{\partial f(x,y)}{\partial y}|_{y=g(x)}~\frac{\partial g(x)}{\partial x}$, and obtain
\begin{eqnarray}
    \frac{\partial g(x)}{\partial x} = -\frac{\partial f(x,y)/\partial x}{\partial f(x,y)/\partial y}|_{y=g(x)}
\end{eqnarray}
\end{lemma}

To compute the flux control coefficients, we now see Eq.~(\ref{eq:ThermoLawFLuxImplicit}) as a constraint between an enzyme level $\enzyme_i$ and the flux $\fluxJ$, assuming that all other enzyme levels are given. This constraint implicitly defines a function $\fluxJ(\enzyme_i)$. To compute the derivative $\partial \fluxJ/\partial \enzyme_i$ (assuming all other enzyme levels are constant), we set $x \rightarrow \enzyme_i$; $y \rightarrow \fluxJ$; $g(x) \rightarrow \fluxJ(\enzyme_i$); and $f(x,y) \rightarrow \mathcal{Y}(\enzyme_i,\fluxJ)$, and obtain:
\begin{align}
\begin{split}
    R^\fluxJ_{\enzyme_l}
    &= \frac{\partial \fluxJ}{\partial \enzyme_l} = - \frac{\partial \mathcal{Y}}{\partial \enzyme_l}\left(\frac{\partial \mathcal{Y}}{\partial \fluxJ}\right)^{-1}
    \\
    &= - \frac{ \prod_{i \neq l} (1 - \fluxJ \cdot (\enzymei~\kcati)^{-1} )}
    {\prod_{i=1}^n (1 - \fluxJ \cdot (\enzymei~\kcati)^{-1})}\cdot
    \frac{-\fluxJ \cdot (\kcatl)^{-1} \cdot \enzyme_l^{-2}}{ \sum_{i=1}^n \frac{-(\enzymei~\kcati)^{-1}}{1 - \fluxJ \cdot (\enzymei~\kcati)^{-1}}}
    \\
    &=
    - \frac{1}
    {1 - \fluxJ \cdot (\enzyme_l~\kcatl)^{-1}} \cdot \frac{\fluxJ \cdot (\kcatl)^{-1} \cdot \enzyme_l^{-2} }{\sum_{i=1}^n (\enzymei~\kcati - \fluxJ)^{-1}}
    \\
    &=
    - \frac{\fluxJ}{\enzyme_l} \cdot \underbrace{\frac{(\enzyme_l~\kcatl - \fluxJ)^{-1}}{\sum_{i=1}^n (\enzymei~\kcati - \fluxJ)^{-1}}}_{C^\fluxJ_l}.
\end{split}
\end{align}
The result is simple: the control coefficients ($C^\fluxJ_l$) are proportional to $(\enzyme_l~\kcatl - \fluxJ)^{-1}$ and sum to 1 as required by the summation theorem.

\subsubsection{Concentration control coefficients}

Using Eq.~(\ref{Appendix:eqn:THsteadyConcentrations}), which we can solve for any $\smet{j}$ in the same way as for $\smet{n}$, we obtain $\smet{j} = \smet{0} \prod_{i=1}^j \Keqi ( 1 - \fluxJ \cdot(\enzymei \kcati)^{-1} )$ and therefore

\begin{equation}
    R^{\smet{j}}_{\enzyme_l}
    =
    \frac{\partial \smet{j}}{\partial \enzyme_l}
    =
    \underbrace{
        \smet{0}~\prod_{i=1}^j \Keqi ( 1 - \fluxJ \cdot (\enzymei \kcati)^{-1})
    }_{\smet{j}}
    \cdot
    \underbrace{
        \frac{ \frac{\partial}{\partial \enzyme_l} ( 1 - \fluxJ \cdot (\enzyme_l \kcatl)^{-1})}{ 1 - \fluxJ \cdot (\enzyme_l \kcatl)^{-1} }
    }_\mathcal{Z}
\end{equation}
for all enzyme indices $l\le j$ (otherwise 0). The first product term is simply $\smet{j}$. The second product term can be rewritten as:
\begin{align}
\begin{split}
    \mathcal{Z} &= - \frac{\frac{\partial \fluxJ}{\partial \enzyme_l} \cdot  (\enzyme_l~\kcatl)^{-1} + \fluxJ \cdot (\kcatl)^{-1} \enzyme_l^{-2} }{ 1 - \fluxJ \cdot (\enzyme_l \kcatl)^{-1} }
    =
    - \frac{R^{\smet{j}}_{\enzyme_l} + \fluxJ \enzyme_l^{-1} }{ \enzyme_l \kcatl - \fluxJ}
    \\
    &=
    \frac{\frac{\fluxJ}{\enzyme_l} \frac{(\enzyme_l~\kcatl - \fluxJ)^{-1}}{\sum_{i=1}^n (\enzymei~\kcati - \fluxJ)^{-1}} - \frac{\fluxJ}{\enzyme_l} }{ \enzyme_l \kcatl - \fluxJ}
    =
    \frac{\fluxJ}{\enzyme_l} \cdot \frac{\frac{(\enzyme_l~\kcatl - \fluxJ)^{-1}}{\sum_{i=1}^n (\enzymei~\kcati - \fluxJ)^{-1}} - 1}{ \enzyme_l \kcatl - \fluxJ}
    =
    \frac{\fluxJ}{\enzyme_l} \cdot \frac{\frac{1}{\sum_{i=1}^n (\enzymei~\kcati - \fluxJ)^{-1}} - \enzyme_l~\kcatl + \fluxJ}{ (\enzyme_l~\kcatl - \fluxJ)^{-2} }
\end{split}
\end{align}
Putting all this together, we obtain the concentration control coefficients
\begin{equation}\label{eq:ConcentrationControlThermodynamic1}
    C^{\smet{j}}_{l}
    =
    \frac{R^{\smet{j}}_{\enzyme_l}}{\fluxJ/\enzyme_l}
    =
    \smet{j}~\left[ \frac{\frac{1}{\sum_{i=1}^n (\enzymei~\kcati - \fluxJ)^{-1}} - \enzyme_l~\kcatl + \fluxJ}{ (\enzyme_l~\kcatl - \fluxJ)^{-2} } \right].
\end{equation}
Again, this formula holds only for $l\le j$ (otherwise $C^{\smet{j}}_{l} = 0$).

\subsubsection{Enzyme-control rule}
\label{sec:THenzymeControlRule}

To show that the control coefficients Eq.~(\ref{eqn:controlCoeffsThermodynamic1}) satisfy the enzyme-control rule, we assume that the rule is correct, insert our formula for control coefficients,  derive from it an expression for the enzyme levels, and compare the result to our formula Eq.~(\ref{Appendix:eqn:optEnzThermo}). We do this now step by step. Starting from the proportionality
\begin{align}
\Cvl \propto \frac{1}{\enzyme_l~\kcatl-\fluxJ} \propto \enzyme_l
\end{align}
we obtain
\begin{align}
\begin{split}
\label{eqn:derivationThermoEnzymeControlRule}
&\frac{1}{\enzyme_l^2~\kcatl-\fluxJ~\enzyme_l} = \mbox{const} = 1/a
\\
\Rightarrow&~ \enzyme_l^2~\kcatl-\fluxJ~\enzyme_l - a =0
\\
\Rightarrow&~ \enzyme_l^2-\frac{\fluxJ}{\kcatl}~\enzyme_l - \frac{a}{\kcatl} =0
\\
\Rightarrow&~  \enzyme_l
= \frac{\fluxJ}{2~\kcatl} \pm \sqrt{\left(\frac{\fluxJ}{2~\kcatl}\right)^2+\frac{a}{\kcatl}}
=\frac{\fluxJ}{\kcatl} \left(\frac{1}{2}\pm \frac{1}{2} \sqrt{1+ \kcatl~ \frac{4~a}{\fluxJ^2}}\right)
\end{split}
\end{align}

The solution with a minus sign is physically meaningless and can be discarded. Remember that we defined $\parthr_i \equiv 1/\kcati$, so we can rewrite Eq.~(\ref{eqn:derivationThermoEnzymeControlRule}) as
\begin{align}
\begin{split}
\enzymei = \fluxJ \parthr_i \left(\frac{1}{2} + \frac{1}{2} \sqrt{1 + (\Psi \parthr_i)^{-1}}\right).
\end{split}
\end{align}
Here we also replaced $\fluxJ^2 / (4a)$ with $\Psi$ by comparing this solution to Eq.~(\ref{Appendix:eqn:optEnzThermo}) (and using the fact that the value of this constant is uniquely determined by the constraint $\sum_i \enzymei = \etotPW$).

\subsubsection{A note on Max-min Driving Force}\label{Appendix:sec:mdf}
The Max-Min Driving Force method (MDF) is a heuristics for finding realistic metabolite concentrations in metabolic models with known flux directions. It relies on the fact that very small driving forces lead to large enzyme demands and should be avoided, while very large driving forces do not further improve the enzyme demand. The MDF heuristics can be seen as a way to reduce enzyme cost. To see this, we start from the thermodynamic rate law and consider a lower bound on the enzyme demand:
\begin{equation}
\label{eq:MDF1}
\enzyme_l = \frac{v_l}{\kcatl} \frac{1}{1-\mbox{e}^{-\theta_l}} \ge \frac{v_l}{\kcatl} ~ \mbox{max}(1,~\frac{1}{\theta_l}).
\end{equation}
where we use the fact that $e^{-x} \geq \max(0, 1-x)$. We now consider again an unbranched pathway with a steady forward flux and a given overall driving force $\theta$. In this case, we obtain the constraints $\theta_l \ge 0$ and $\sum_l \theta_l =\theta$. The forces $\theta_l$ are not free variables, but a function $\theta_l =\ln \Keq_l - (\ln c_l - \ln c_{l-1})$ of the metabolite concentrations, which in turn are constrained by physiological ranges. Let us see how the MDF principle can be derived from our present optimality problem. Since pathway flux and total enzyme demand scale proportionally at given metabolite concentrations, a flux maximization at a fixed enzyme budget is equivalent to minimizing the total enzyme demand $\sum_l \enzyme_l$ at a given flux. With Eq.~(\ref{eq:MDF1}), we can approximate this demand as
\begin{equation}
    \sum_l \enzyme_l \ge \sum_{l=1}^n \frac{v_l}{\kcatl}  + \sum_{l: \theta_l<1} \frac{v_l}{\kcatl} \left(\frac{1}{\theta_l}-1\right) \ge  \sum_{l=1}^n \frac{v_l}{\kcatl}  + \mbox{max}_{l: \theta_l<1} \frac{v_l}{\kcatl}  \left(\frac{1}{\theta_l}-1\right)
\end{equation}
where $l: \theta_l<1$ denotes the indices of reactions with driving forces smaller than 1. The first term describes the constant enzyme demand of a hypothetical model  in which all enzymes work at their maximal speed. The second term concerns  reactions with driving forces smaller than 1 (if such reactions exist) and denotes the maximal value of  $\frac{v_l}{\kcatl} \left(\frac{1}{\theta_l}-1\right)$ among these reactions. To minimize the overall enzyme demand, we choose the heuristics of minimizing this term. This is equivalent to maximizing
\begin{equation}
    \mbox{min}_{l: \theta_l<1} \frac{\kcatl}{v_l} \theta_l.
\end{equation}
where $l$ runs again over all reactions with a driving force smaller than 1. Thus, we postulate that the smallest driving force in the pathway (weighted by $\frac{\kcatl}{v_l}$) should be as large as possible. The original MDF driving force method employs some additional simplifications. First, we neglect the pre-factor $\frac{\kcatl}{v_l}$ (assuming that nothing is known about enzyme kinetics). Second, if all the reactions have driving forces larger than 1, we let the index $l$ run over all reactions, assuming that it will still be the smallest driving force that causes the largest enzyme cost.


\subsection{Reversible mass-action kinetics}
\label{Appendix:ana_ma_derivation}

\subsubsection{Steady-state flux}

Here we will show the full derivation of the optimal solution in the case of reversible mass-action rate laws. We start by reminding ourselves that the rate law for each reaction is given by:
\begin{align}\label{Appendix:eqn:ana_ma}
    \fluxi = \enzymei ~ \parmm_i^{-1}~(\smet{i-1} - \smet{i} / \Keqi)\,,
\end{align}
and the pathway flux is thus (as in Eq.~(\ref{eqn:ana_ma_flux_upper_bound})):
\begin{align}
    \fluxJ  &= \etotPW ~ \left( \sum_i \frac{\parmm_i}{\smet{i-1} - \smet{i} / \Keqi} \right)^{-1},
\end{align}
where we replaced the inequality by an equality since we are looking for the maximal flux.

While $\fluxJ$ can in theory be maximized by equating the gradient with respect to all metabolite levels to $0$, the resulting system of equations would be difficult to solve. Instead, we will use a different approach that involves finding an expression for $\fluxJ$ as a function of the different enzyme levels (rather than metabolite levels).

First, we use Eq.~(\ref{Appendix:eqn:ana_ma}) to obtain a formula for $\smet{i}$. By equating $\fluxi = \fluxJ$ and applying it recursively we get:
\begin{align}
\begin{split}\label{eq:MAsImplicit}
    \smet{1} &= K^\mathrm{eq}_1 \left(\smet{0} - \frac{\fluxJ \parmm_1}{\enzyme_1}\right)
    \\
    \smet{2} &= K^\mathrm{eq}_2  \left(\smet{1} - \frac{\fluxJ \parmm_2}{\enzyme_2}\right)
    =
    K^\mathrm{eq}_2 \left(K^\mathrm{eq}_1 \left(\smet{0} - \frac{\fluxJ \parmm_1}{\enzyme_1}\right) - \frac{\fluxJ \parmm_2}{\enzyme_2}\right)
    \\
    &=
    \smet{0} K^\mathrm{eq}_1 K^\mathrm{eq}_2 - \fluxJ \left( \frac{\parmm_{1}}{\enzyme_{1}} K^\mathrm{eq}_1 K^\mathrm{eq}_2 + \frac{\parmm_2}{\enzyme_2} K^\mathrm{eq}_2\right)
    \\
    \smet{3} &=  \smet{0} K^\mathrm{eq}_1 K^\mathrm{eq}_2 K^\mathrm{eq}_3 - \fluxJ \left(\frac{\parmm_{1}}{\enzyme_{1}} K^\mathrm{eq}_1 K^\mathrm{eq}_2 K^\mathrm{eq}_3 + \frac{\parmm_2}{\enzyme_2} K^\mathrm{eq}_2 K^\mathrm{eq}_3 + \frac{\parmm_3}{\enzyme_3} K^\mathrm{eq}_3\right)
    \\
    &\vdots
    \\
    \smet{n} &= \smet{0}~\prod_{i=1}^n \Keqi - \fluxJ~\sum_{j=1}^{n}\frac{\parmm_j}{\enzyme_j} \prod_{i=j}^{n} \Keqi
    =
    \smet{0}~\Keqtot - \fluxJ~\sum_{j=1}^{n}\frac{\parma_j}{\enzyme_j}
\end{split}
\end{align}
where we use the fact that $\Keq = \prod_{i=1}^n \Keqi$ (i.e.~the equilibrium constant of the pathway net reaction), and substituting $\parma_j \equiv \parmm_j \prod_{i=j}^{n} \Keqi$. Solving for $\fluxJ$ we get:
\begin{equation}
\label{Appendix:eqn:MAjExplicit}
    \fluxJ = \frac{ \smet{0}~\Keqtot ~-~ \smet{n} }{ \sum_{j=1}^{n} \parma_j (\enzyme_j)^{-1} }\,.
\end{equation}

\subsubsection{Flux control coefficients}
\label{sec:MAfluxControl}

The steady-state flux is given by Eq.~(\ref{Appendix:eqn:MAjExplicit}).
By taking the partial derivative with respect to enzyme levels, we obtain the flux response coefficients
\begin{align}
 R^\fluxJ_{\enzyme_l} = \frac{\partial}{\partial \enzyme_l} \frac{ \smet{0}~\Keqtot ~-~ \smet{n} }{\sum_{i=1}^n \parma_i/\enzymei} =
 - \frac{ \smet{0}~\Keqtot ~-~ \smet{n} }{(\sum_{i=1}^n \parma_i/\enzymei)^2} \cdot \left(-\frac{\parma_l}{\enzyme_l^2}\right)
 = \fluxJ ~ \frac{\parma_l/\enzyme_l^2}{\sum_{i=1}^n  \parma_i/\enzymei}.
\end{align}
After dividing by the enzyme elasticities $E^{\flux_l}_{\enzyme_l}=\fluxJ/\enzyme_l$, we obtain the flux control coefficients
\begin{align}
\label{eq:MAfluxControl}
C^\fluxJ = \frac{R^\fluxJ_{\enzyme_l}}{E^{\flux_l}_{\enzyme_l}} = \frac{\parma_l/\enzyme_l}{\sum_{i=1}^n  \parma_i/\enzymei}.
\end{align}


\subsubsection{Minimum enzyme demand / maximal flux}

Now, in order to maximize $\fluxJ$ we need to minimize the denominator (the numerator is a constant). The variables ($\enzyme_j$) have to satisfy the constraint $\sum_j \enzyme_j \le \etotPW$. To find the minimal value for the denominator, we use the Lagrange method:
\begin{align}
    \begin{split}
        0 &= \frac{\partial}{\partial \enzyme_j} \left[\sum_{j=1}^{n} \parma_j (\enzyme_j)^{-1} - \lambda \left(\sum_j \enzyme_j - \etotPW\right)\right]_{\opt{\enzyme_j}}
        =
        -\parma_j (\opt{\enzyme_j})^{-2} - \lambda
    \end{split}
\end{align}
which shows that $\opt{\enzyme_j} \propto \sqrt{\parma_j}$. Since we know the sum of all the enzyme levels, $\etotPW$, we can also find the proper scaling factor, i.e.:
\begin{align}\label{Appendix:eqn:ana_ma_enzyme_solution}
    \opt{\enzyme_j} = \etotPW ~ \frac{\sqrt{\parma_j}}{\sum_{j=1}^n \sqrt{\parma_j}} = \etotPW ~ \sqrt{ \frac{\parma_j}{\normhalf{\parma} }}
\end{align}
where $\boldsymbol{\parma}$ is the vector of all $\parma_j$, and $\normhalf{\cdot}$ is the l$_{1/2}$ norm.

Furthermore, we can calculate the maximal achievable flux $\opt{\fluxJ}$ by plugging in the $\opt{\enzyme_j}$ values:
\begin{align}
    \begin{split}
        \opt{\fluxJ} &= \frac{ \smet{0}~\Keqtot ~-~ \smet{n} }{ \sum_{j=1}^{n} \parma_j (\opt{\enzyme_j})^{-1} }
        =
        \frac{ \smet{0}~\Keqtot ~-~ \smet{n} }{ \sum_{j=1}^{n} \parma_j ~ \frac{1}{\etotPW} \sqrt{ \frac{\normhalf{\parma} }{\parma_j}} }
         =
        \etotPW \frac{ \smet{0}~\Keqtot ~-~ \smet{n} }{ \sqrt{\normhalf{\parma}} \sum_{j=1}^{n} \sqrt{ \parma_j} }
        =
        \etotPW ~ \frac{ \smet{0}~\Keqtot ~-~ \smet{n} }{\normhalf{\parma}}
    \end{split}
\end{align}

An interesting consequence of Eq.~(\ref{Appendix:eqn:ana_ma_enzyme_solution}) that we can draw from this optimization comes from looking at optimal ratios between consecutive enzymes:
\begin{align}
    \begin{split}
    \frac{\opt{\enzyme_{j}}}{\opt{\enzyme_{j-1}}}
    =
    \sqrt{\frac{\parma_{j}}{\parma_{j-1}}}
    =
    \sqrt{ \frac{\parmm_{j}}{\parmm_{j-1}~K^\mathrm{eq}_{j}}}
    =
    \sqrt{ \frac{K_{\mathrm{M},j} ~ \kcatx{j-1}}{K_{\mathrm{M},j-1} ~ \kcatx{j} ~ K^\mathrm{eq}_{j}}}\,.
    \end{split}
\end{align}
Interestingly, the ratio depends only on the $\km$ and $\kcat$ values of the two reactions and is independent of all other enzymes in the system. This might be a design principle supporting the existence of regulatory mechanisms that ensure these ratios are maintained even if the total expression level changes.

\subsubsection{Connectivity theorem for flux control coefficients}
\label{sec:MAfluxControlConnectivityTheorem}

The connectivity theorem for flux control coefficients reads $\Cvmat~\Evcmat=0$. Here we verify this explicitly for an unbranched pathway with reversible mass-action kinetics. With the control coefficients Eq.~(\ref{eq:MAfluxControl}) and the metabolite elasticities for the reversible mass action rate law
\begin{align}
\label{eq:MAelasticities}
\Evlci= \enzyme_l ~ \parmm_l^{-1} ~ (\delta_{i,l-1} - \delta_{il} / K^\mathrm{eq}_l).
\end{align}
we obtain
\begin{align}
\begin{split}
    (\Cvmat~\Evcmat)_i
    &=
    \sum_l \frac{\parma_l/\enzyme_l}{\sum_j \parma_j/\enzyme_j} ~ \enzyme_l ~ \parmm_l^{-1} ~ (\delta_{i,l-1} - \delta_{il} / K^\mathrm{eq}_l)
    \propto
    \sum_l \parma_l ~\parmm_l^{-1} ~(\delta_{i,l-1} - \delta_{il} / K^\mathrm{eq}_l)
    \\
    &=
    \parma_{i+1} ~\parmm_{i+1}^{-1} - \parma_{i} ~\parmm_{i}^{-1} ~ \cdot ~ 1/\Keqi
    \\
    &=
    \prod_{j=i+1}^n \Keqj - \prod_{j=i}^n \Keqj  ~ \cdot ~ 1/\Keqi
    \\
    &=
    \prod_{j=i+1}^n \Keqj - \prod_{j=i+1}^n \Keqj
    = 0\,.
\end{split}
\end{align}

\subsubsection{Enzyme-control rule}
\label{sec:MAenzymeControlRule}

The enzyme levels in optimal state Eq.~(\ref{eqn:solutionMassAction}) read
\begin{align}
\opt{\enzyme}_l= \etotPW \sqrt{\frac{\parma_l}{\normhalf{\vec{\parma}}}}.
\end{align}
By inserting this into the formula Eq.~(\ref{eq:MAfluxControl}) for control coefficients, we obtain (where the constant denominator is a normalisation term)
\begin{align}
\opt{C^\fluxJ_l} \equiv \frac{\parma_l~\left(\etotPW \sqrt{\frac{\parma_l}{\normhalf{\vec{\parma}}}}\right)\inv}{\mbox{const}} \propto \sqrt{\parma_l},
\end{align}
 which is proportional to the enzyme level $\opt{\enzyme}_l$ itself.


\subsection{Haldane rate law}

\subsubsection{Steady-state concentrations}
For this derivation, we first use the notation in the original publication by \citet{HeinrichKlipp1996}. For a unbranched pathway at steady-state (with flux $J$ in all reactions), the Haldane rate law dictates that:
\begin{align}
    \fluxJ
    =
    \frac{\vmaxx{+l} ~ \smet{l-1}/K_{{\mathrm S};l} - \vmaxx{-l} ~ \smet{l}/K_{{\mathrm P};l}}{1 + \smet{l-1}/K_{{\mathrm S};l} + \smet{l}/K_{{\mathrm P};l}}\,.
\end{align}
Using this formula, we can solve for $\smet{l}$ given all other parameters (including $\smet{l-1}$) and get the following recursion:
\begin{align}
    \smet{l} = \smet{l-1} \frac{K_{{\mathrm P};l}}{K_{{\mathrm S};l}} \frac{\vmaxx{+l} - \fluxJ}{\vmaxx{-l} + \fluxJ} - \fluxJ \frac{K_{{\mathrm P};l}}{\vmaxx{-l} + \fluxJ}
\end{align}
which can be solved to give:
\begin{align}
    \smet{l}^{\rm st} = \smet{0} \left(\prod_{i=1}^l \frac{K_{{\mathrm P};i}}{K_{{\mathrm S};i}} \frac{\vmaxx{+i}-\fluxJ}{\vmaxx{-i}+\fluxJ}\right) - \fluxJ \sum_{i=1}^l \frac{K_{{\mathrm S};i}}{\vmaxx{+i} - \fluxJ} \prod_{j=i}^l \frac{K_{\mathrm P};j}{K_{\mathrm S};j} \frac{(\vmaxx{+j} - \fluxJ)}{(\vmaxx{-j} + \fluxJ)}
\end{align}

From now on, we will replace $\vmaxx{\pm i}$ with $\enzymei \cdot k^{\mathrm{cat}}_{\pm i}$ in order to better match the notation of this paper. If we use the solution for the steady-state concentration of $\smet{n}$ we can write:
\begin{align}
\label{eq:HaldaneConcentrationConditionGivenJ}
    f(\fluxJ; \boldsymbol{\enzyme})
    \equiv
    \smet{0} \left(\prod_{i=1}^n \frac{K_{{\mathrm P};i}}{K_{{\mathrm S};i}}
    \frac{\enzymei ~\kcatplusi -\fluxJ}{\enzymei ~\kcatminusi + \fluxJ}\right)
- \fluxJ \sum_{i=1}^n \frac{K_{{\mathrm S};i}}{\enzymei~ \kcatplusi - \fluxJ}
\prod_{j=i}^n \frac{K_{{\mathrm P};j}}{K_{{\mathrm S};j} }
\frac{(\enzymei ~k^{\mathrm{cat}}_{+j} - \fluxJ)}{(\enzymei~ k^{\mathrm{cat}}_{-j} + \fluxJ)} - \smet{n}
    =
    0\,.
\end{align}

Solving this equality (i.e., finding the roots of $f(\fluxJ; \enzymev)$) would give us an expression for $\fluxJ(\enzymev)$ -- the flux as a function of the enzyme levels. This can be used in different ways. First, we can determine the flux response coefficients by implicit differentiation (Lemma \ref{lemma:implicitDifferentiation}: $R^\fluxJ_{\enzyme_i}=-\frac{\partial f/\partial \enzyme_i}{\partial f/\partial \fluxJ}$), and by dividing by $\fluxJ/\enzyme_i$ we obtain the flux control coefficients. Second, we can find an optimal metabolic state by minimizing $\sum_i\enzyme_i$ at a given flux $\fluxJ$, and requiring Eq.~(\ref{eq:HaldaneConcentrationConditionGivenJ}) as a constraint (with Lagrange multiplier $\lambda$). Optimization using the Lagrange method would lead to the optimality condition $\partial f/\partial \enzyme_i = \lambda$. However, since the derivatives are complicated and $\fluxJ$ and $\lambda$ are unknown, this is hard to solve.

The most efficient method we currently have for solving this optimization problem is, unfortunately, not analytical. First, we start by writing $\etotPW / \fluxJ$ as a function of the metabolite concentrations:
\begin{align}
    \frac{\etotPW}{\fluxJ}
    =
    \frac{\sum_i \enzymei}{\fluxJ}
    =
    \sum_i \frac{1 + \smet{i-1}/K_{{\mathrm S};i} + \smet{i}/K_{{\mathrm P};i}}{\kcatplusi ~ \smet{i-1}/K_{{\mathrm S};i} - \kcatminusi ~ \smet{i}/K_{{\mathrm P};i}}\,.
\end{align}

We showed previously that this function is convex with respect to the metabolite log-concentrations ($\ln{\vec{\smet}}$) and therefore has a single (global) minimum which is easy to find numerically \cite{LiebermeisterNoor2015, NoorFlamholz2016}.
% --------------------------------------------------------------------

\subsection{Reactions with cofactors, side substrates, and side products: effective kinetic constants}
\label{sec:Appendix:effectiveKineticConstants}

The pathways considered in this paper consist of uni-uni reactions $S \ce{<=>} P$. However, all the results apply also to reactions with several substrates and products if only one of the substrates and one of the products have variable concentrations, while all other concentrations are predefined. As an illustrating example, we consider a reaction with stoichiometric coefficients of 1, substrates $s$ (variable) and $a$ (constant), and products $p$ (variable) and $b$ (constant). There are various ways to generalize the Haldane rate law to reactions with several substrates or products. One of them, the convenience kinetics \cite{LiebermeisterKlipp2006}, for this reaction reads
\begin{align}
\flux = \enzyme \frac{\kcatplus ~ s/\kmx{S} ~ a/\kmx{A} - \kcatminus ~ p/\kmx{P} ~ b/\kmx{B}}{(1 + s / \kmx{S})(1 + a / \kmx{A}) + (1 + p / \kmx{P})(1 + b / \kmx{B}) - 1}.
\end{align}

With the abbreviations $\sigma = a/\kmx{A}$ and $\pi=b/\kmx{B}$, we obtain
\begin{align}
\begin{split}
v &= \enzyme \frac{\kcatplus ~ \sigma ~ s/\kmx{S} - \kcatminus ~ \pi ~ p/\kmx{P}}{(1+s/\kmx{S})(1+\sigma) + (1+p/\kmx{P})(1+\pi)-1}
\\
 &= \enzyme \frac{\kcatplus ~ \sigma ~ s/\kmx{S} - \kcatminus ~ \pi ~ p/\kmx{P}}
{(1+\sigma) + (1+\pi) -1 +(1+\sigma) s/\kmx{S} + (1+\pi) p/\kmx{P}}
\\
 &= \enzyme \frac{\frac{\sigma}{1+\sigma+\pi} \kcatplus s/\kmx{S} - \frac{\pi}{1+\sigma+\pi} \kcatminus p/\kmx{P}}
{1+ \frac{1+\sigma}{1+\sigma+\pi}~s/\kmx{S}  +  \frac{1+\pi}{1+\sigma+ \pi}~ p/\kmx{P}}
\end{split}
\end{align}

and by defining
\begin{align}
\begin{split}
    \widehat{\kmx{S}} &=  \frac{1 + \sigma + \pi}{1 + \sigma} \kmx{S}, \qquad
    \widehat{\kmx{P}} = \frac{1 + \sigma + \pi}{1 + \pi} \kmx{P}
    \\
    \widehat{\kcatplus} &= \frac{\sigma}{1 + \sigma} \kcatplus, \qquad
    \widehat{\kcatminus} = \frac{\pi}{1 + \pi} \kcatminus
\end{split}
\end{align}

we can write this in the form of our uni-uni rate law:
\begin{align}
    \flux = \enzyme \cdot \frac{\widehat{\kcatplus} ~ s/\widehat{\kmx{S}} - \widehat{\kcatminus} ~ p/\widehat{\kmx{P}} }{(1 + s / \widehat{\kmx{S}}) + (1 + p / \widehat{\kmx{P}}) - 1}
\end{align}
with effective ($\hat{\cdot}$) parameters. From the Haldane relationship, we obtain the  effective equilibrium constant:
\begin{align}
\label{eqn:effectiveDrivingForce}
\widehat{\Keq}
=
\frac{\widehat{\kcatplus}}{\widehat{\kcatminus} } \cdot \frac{\widehat{\kmx{P}}}{\widehat{\kmx{S}} }
=
\frac{\sigma}{\pi} \frac{\cancel{(1+\pi)}}{\cancel{(1+\sigma)}} \frac{\kcatplus}{\kcatminus} \cdot \frac{\cancel{(1+\sigma+\pi)}}{\cancel{(1+ \sigma+\pi)}} \frac{\cancel{(1+\sigma)}}{\cancel{(1+\pi)}} \frac{\kmx{P}}{\kmx{S} }
=
\frac{a}{b} \frac{\kcatplus}{\kcatminus} \frac{\kmx{P} \kmx{B}}{\kmx{S} \kmx{A}}
=
\frac{a}{b} \Keq\,,
\end{align}
where we used the Haldane relationship for the original reaction: $\Keq=\frac{\kcatplus}{\kcatminus} \frac{\kmx{P} \kmx{B}}{\kmx{S} \kmx{A}}$.

The driving force $\theta=\ln \Keq - \ln \frac{p~b}{s~a}$ of a reaction, as a thermodynamic quantity, cannot depend on how the rate law is written. With the original rate law, it depends on the (true) equilibrium constant as well as on all four reactant concentrations. But if we ignore A and B in the rate law and simply define our equilibrium constant as the ratio $b^{eq}/a^{eq}$ in some imagined equilibrium state, the resulting driving force would be different from our original driving force and the term $1-\mbox{e}^{-\theta}$ will be wrong or, even worse, the new $\theta$ will have the opposite sign and  be opposite to the flux direction. To avoid this problem, there are two possibilities: either we use the effective equilibrium constant Eq.~(\ref{eqn:effectiveDrivingForce}), which contains the constant ignored concentrations, or we compute the driving force with an "external" extra term,
\begin{align}
\theta=\ln \Keq - \underbrace{\ln \frac{b}{a}}_{\theta_{\rm ext}} - \ln \frac{p}{s}.
\end{align}
If we compare the thermodynamic force to  voltage in an electric circuit, A and B would act like an external voltage source.

% --------------------------------------------------------------------

\subsection{Enzyme-control rule in models with constraints on enzyme and metabolite levels}
\label{sec:EnzymeControlRuleMetaboliteConstraintProof}

We assume an unbranched metabolic pathway in steady state. By considering the steady-state fluxes $\vec{v} = \vec{v}^{\rm st}(\enzymev)$ and steady-state metabolite concentrations $\vsmet = \vsmet^{\rm st}(\enzymev)$ and taking derivatives by $\enzyme_l$, we obtain the response coefficients $R^{\flux_i}_{\enzyme_l} = \partial \flux_i^{\rm st}/\partial \enzyme_l$ and  $R^{\smet{i}}_{\enzyme_l} = \partial \smet{i}^{\rm st}/\partial \enzyme_l$.
We now consider the optimality problem (same as in Eq.~(\ref{eq:OptProblemWithDensityConstraint})):
\begin{eqnarray*}
\mbox{Maximize}\; \zweightv \cdot \vv \quad \mbox{s.t.}
\quad \aweightv \cdot \enzymev + \bweightv \cdot \vsmet \le \rho
\end{eqnarray*}
where $\vv$, $\vsmet$, and $\enzymev$ denote reaction fluxes, metabolite concentrations, and enzyme levels and where $\rho$ is the upper bound on the total density. The maximization objective is a linear  benefit function $\zweightv \cdot \vv$, scoring the fluxes with linear weights $z_i$, while the constrained density is linear in all the concentrations with linear weights $a_l$ (for enzymes) and  $b_i$ (for metabolites), e.g.~representing effective molecule sizes.  Optimization with a Lagrange multiplier $\lambda$ yields
\begin{align}
    \mbox{Maximize} ~~~~ {\mathcal L}(\enzymev)
    &=
    \zweightv\trans {\vv^{\rm st}}(\enzymev) - \lambda ~ \left[ \aweightv\trans \enzymev + \bweightv\trans \vsmet^{\rm st}(\enzymev) - \rho \right].
\end{align}
The Lagrangian yields the optimality condition:
\begin{align}
\begin{split}
0 = \frac{\partial {\mathcal L}}{\partial {\enzymev}} &= \vec{z}\trans \frac{\partial \vv^{\rm st}}{\partial \enzymev} - \lambda ~\left[\vec{a}\trans + \vec{b}\trans \frac{\partial \vsmet^{\rm st}}{\partial \enzymev} \right]
\\
 &=  \vec{z}\trans \mathbf{R}^{\vec{v}}_\enzymev -  \lambda \left[\vec{a}\trans + \vec{b}\trans \Rcmat_\enzymev \right]
\\
\Rightarrow \vec{a}\trans &=  \frac{1}{\lambda} \vec{z}\trans \mathbf{R}^{\vec{v}}_\enzymev  -  \vec{b}\trans \Rcmat_\enzymev\,.
\end{split}
\end{align}
By splitting the response matrices into control and enzyme elasticity matrices, $\mathbf{R}^x_\enzymev =  \mathbf{C}^x E^{v}_\enzymev = \mathbf{C}^x ~\diag(\vv)~ \diag(\enzymev)^{-1}$, we obtain
\begin{align}
\begin{split}
\vec{a}\trans
&=
\left[\frac{1}{\lambda} \vec{z}\trans~ \mathbf{C}^{\vec{v}} - \vec{b}\trans \Ccmat\right]~\diag(\vec{v}) ~\diag(\enzymev)^{-1}
\\
\Rightarrow \enzymev\trans ~\diag(\vec{a})~\diag(\vv)\inv
&=
\left[\frac{1}{\lambda} ~\vec{z}\trans \mathbf{C}^{\vec{v}} - \vec{b}\trans \Ccmat\right]\,.
\end{split}
\end{align}
In the case of an unbranched pathway, i.e.~with the same steady-state $\flux_i^{\rm st} = \fluxJ$ in all reactions, we can define the benefit function $\vec{z}\trans = (1,0,\ldots,0)$ which will give us $\vec{z}\trans \vv = \flux_1 = \fluxJ$. In this case $\vec{z}\trans \mathbf{C}^{\vec{v}}$ will simply be the first column of the $\mathbf{C}^{\vec{v}}$ matrix, which we now call $\Cvmat$. In addition, we can choose density constraints with uniform weights for all enzymes and for all metabolites ($\vec{a} = a \vec{1}$, $\vec{b} = b \vec{1}$). Then, the enzyme profile becomes
\begin{align}
  \label{eq:EnzControlRule1}
\enzymev  =  \frac{\fluxJ}{a} \left[\frac{1}{\lambda} ~ \Cvmat -  b ~ \vec{1}\trans \Ccmat\right].
\end{align}

Our new enzyme-control rule thus reads, as a proportionality (and marking the optimal state by $\opt{}$)
\begin{align}
\opt{\enzyme}_l  \propto C^{\fluxJ*}_l  - \lambda~ b~ \sum_i C^{\smet{i}*}_l.
\end{align}

In our density constraint in Eq.~(\ref{eq:OptProblemWithDensityConstraint}), with a predefined overall density $\rho$, there is no explicit bound $\etotPW$ on the sum  of the enzyme levels. However, given the sum of enzyme levels  $\etotPWopt$ that emerges from the solution, we can write the enzyme-control rule with no unknown parameters. To derive it,  we write Eq.~(\ref{eq:EnzControlRule1}) as
\begin{align}
    \opt{\enzyme}_l = \frac{\fluxJ}{a~\lambda} C^{\fluxJ*}_l  -  \frac{b \opt{\fluxJ}}{a}~ \sum_i C^{\smet{i}*}_l
\end{align}
We can then sum over $l$ and get:
\begin{align}
    \etotPWopt = \sum_l \opt{\enzyme}_l = \frac{\opt{\fluxJ}}{a~\lambda} \sum_l C^{\fluxJ*}_l  -  \frac{b \opt{\fluxJ}}{a}~ \sum_i \sum_l C^{\smet{i}*}_l = \frac{\opt{\fluxJ}}{a~\lambda} \cdot 1 - \frac{b \fluxJ}{a} \cdot \sum_i 0,
\end{align}
where in the last step we used the summation theorems for flux and metabolite control coefficients. We can solve this for $\lambda = \opt{\fluxJ}~ (a~ \etotPW)^{-1}$ and obtain the optimal enzyme levels
\begin{align}
    \opt{\enzyme}_l = \etotPWopt~ C^{\fluxJ*}_l  - \frac{b}{a} ~\opt{\fluxJ}~ \sum_i C^{\smet{i}*}_l.
\end{align}


\subsection{Sufficient condition for stable states in unbranched pathways}
\label{Sec:Appendix:stability}

Here we show that a steady state in an unbranched metabolic pathway is stable if (but maybe not only if) the first reaction 1 is reversible (i.e.~it has a non-zero product elasticity), the last reaction is not completely saturated (i.e.~it has a non-zero substrate elasticity), and in all other reactions the substrate elasticity  is larger than the  (absolute) product elasticity. Note that for reversible mass-action rate laws, the first two conditions are automatically satisfied and the latter condition is satisfied if $k_{+i}>k_{-(i-1)}$.

\textbf{Proof}
A metabolic state is asymptotically stable if all the Jacobian eigenvalues are negative (i.e.~they have negative real parts). A sufficient (but not necessary) condition for stable metabolic states can be obtained from Gershgorin's disc theorem, which we recall here:

\begin{theorem}
Let $\mat{A}$ be a square matrix. Each diagonal element $a_{ii}$ is associated with a closed disc $\smet{i}=D_{i}(a_{ii},\sum_{j} |a_{ij}|)$ in the complex plane, with center $a_{ii}$ and radius $\sum_{j} |a_{ij}|$. The theorem states that all eigenvalues of $\mat{A}$ must lie in the union of all these discs. Since the theorem applies both to $\mat{A}$ and to its transpose, each diagonal element gives rise to two discs with the same center, but different radii  $\sum_{j} |a_{ij}|$ and $\sum_{j} |a_{ji}|$.
\end{theorem}

For a real-valued matrix, this means: our system is stable if for all $i$, $a_{ii}+\sum_{j}|a_{ij}| <0$ or if for all $i$, $a_{ii}+\sum_{j}|a_{ji}| <0$.

We now apply this theorem to an unbranched metabolic chain with 4 reactions and 3 internal metabolites A, B, C:

\begin{align}
S\stackrel{1}{\rightarrow}A\stackrel{2}{\rightarrow}B\stackrel{3}{\rightarrow}C\stackrel{4}{\rightarrow}P
\end{align}

The system has no conservation relations.
From the stoichiometric matrix

\begin{align}
\mat{N}=\left(
  \begin{array}{rrrr}
	  1 & -1 &  0 &  0 \\
	  0 &  1 & -1 &  0 \\
	  0 &  0 &  1 & -1
  \end{array}
\right)
\end{align}

and the metabolite elasticity matrix
\begin{align}
\Eunc=\left(
  \begin{array}{rrr}
	-g^{1}_{A}& 0 & 0\\
	g^{2}_{A}& -g^{2}_{B}& 0 \\
	0 & g^{3}_{B}& -g^{3}_{C} \\
	0 & 0 & g^{4}_{C} \\
  \end{array}
\right),
\end{align}
parameterised by positive values $g$, we obtain the Jacobian matrix
\begin{align}
\mat{A}=\Nmat~\Eunc \left(
  \begin{array}{ccc}
	-(g^{1}_{A}+g^{2}_{A}) & g^{2}_{B} & 0\\
	g^{2}_{A} & -(g^{2}_{B}+g^{3}_{B})& g^{3}_{C} \\
	0 & g^{3}_{B}& -(g^{3}_{C}+g^{4}_{C})
  \end{array}
\right).
\end{align}
Applying Gershgorin's theorem, from the condition for matrix columns\footnote{Incidentally, from the condition for rows we obtain another (alternative) set of sufficient conditions
\begin{align}
\begin{split}
  -(g^{1}_{A}+g^{2}_{A}) + g^{2}_{B} &< 0 \\
 	-(g^{2}_{B}+g^{3}_{B}) + (g^{2}_{A} + g^{3}_{C}) &< 0 \\
 -(g^{3}_{C}+g^{4}_{C}) + g^{3}_{B} &< 0.
\end{split}
\end{align}
These conditions are satisfied, for example, if all elasticities are non-zero, if the product elasticity $g^{1}_{A}$ of the first reaction is equal or larger than the product elasticity $g^{2}_{B}$ of  the second reaction,  if the substrate elasticity of the last reaction  is equal or larger that the substrate elasticity $g^{3}_{C}$ of the third reaction, and if $g^{2}_{A}-g^{2}_{B} < g^{3}_{B}-g^{3}_{C}$. For a reversible mass-action kinetics $v = e[k_{+} s - k_{-}p]$ the latter condition would mean: $\enzyme_{2}[k^{2}_{+}-k^{2}_{-}] <\enzyme_{3}[k^{3}_{+}-k^{3}_{-}]$ or  $\frac{\enzyme_{3}}{\enzyme_{2}} > \frac{k^{2}_{+}-k^{2}_{-}}{k^{3}_{+}-k^{3}_{-}} = \frac{v^{\rm std}_{2}}{v^{\rm std}_{3}}$ where the ``standard velocity'' $v^{\rm std}_{l}$ denotes the rate that a reaction $l$ would show at unit metabolite and enzyme levels.}, we obtain the  sufficient stability conditions
\begin{align}
\begin{split}
  -(g^{1}_{A}+g^{2}_{A}) + g^{2}_{A} &< 0  \\
 	-(g^{2}_{B}+g^{3}_{B}) + (g^{2}_{B} + g^{3}_{C}) &< 0  \\
 -(g^{3}_{C}+g^{4}_{C}) + g^{3}_{C} &< 0.
\end{split}
\end{align}

To guarantee a stable steady state, all three inequalities must hold. They are  satisfied whenever $g^{1}_{A}>0$ (reaction 1 is not completely irreversible), $g^{4}_{C}>0$ (reaction 4 is not completely saturated), and $g^{3}_{B}>g^{3}_{C}$ (the substrate elasticity of reaction 3 is larger than the (absolute) product elasticity of this reaction). For longer metabolic chains, we obtain the same type of conditions: the steady state will be stable if (but not only if) the first reaction is not completely irreversible, the last reaction is not completely saturated, and in every reaction in between, the substrate elasticity  is larger than the  (absolute) product elasticity.

\clearpage

\bibliographystyle{unsrtnat}
\bibliography{bibliography}

\end{document}
